function dSc_dt=iGEM_enzyme_function(t,Amounts)
%%
% Amounts = (Amt_Cellulose, Amt_Cellobiose, Amt_Glucose)
% t = time
% iGEM 2011, Team Synergy, Edinburgh
% Modelling the kinetic outcome of enzamatic reactions
% File written by Yassen Abbas
% File last modified 07/09/2011

%% Define constants

global k1r E1B Rs S0 G2 K1IG K1IG2 G X K1IX k2r  E2B K2IG2 K2IG K2IX k3r E2F K3M K3IG K3IX K1ad E1TZ E1max K2ad E2TZ E2max

Rs=Amounts(1)/S0;

E1F=1/2*(-1/K1ad + E1TZ-E1max*Amounts(1) + sqrt((-1/K1ad + E1TZ - E1max*Amounts(1))^2 + 4*E1TZ/K1ad));
E1B=(E1max*K1ad*E1F*Amounts(1))/(1+K1ad*E1F);

E2F=1/2*(-1/K2ad + E2TZ - E2max*Amounts(1) + sqrt((-1/K2ad + E2TZ - E2max*Amounts(1))^2 + 4*E2TZ/K2ad));
E2B=(E2max*K2ad*E2F*Amounts(1))/(1+K2ad*E2F);


% Define rates of reaction

r(1)=(k1r*E1B*Rs*Amounts(1))/(1+(G2/K1IG2)+(G/K1IG)+X/K1IX);

r(2)=(k2r*(E1B+E2B)*Rs*Amounts(1))/(1+(G2/K2IG2)+(G/K2IG)+(X/K2IX));
 
 r(3)=(k3r*E2F*G2)/(K3M*(1+(G/K3IG)+(X/K3IX)+G2));
 
% Differential equations

dSc_dt =[(-r(1)-r(2)); 1.056*r(1)-r(3); 1.111*r(2)+1.053*r(3);];


end
